/* ============================================================================================= */
/*          UNIVERSITAT JAUME I - DEPARTAMENTO DE INGENIERÍA Y CIENCIA DE LOS COMPUTADORES       */
/*                            CURSO 'IoT CON ARDUINO Y ROBOT BUM'                                */
/*                   (c) 2017 Germán León, Raul Marín y José Vicente Martí                       */
/*                                                                                               */
/*                     Ejercicio 3: Cambio de color del LED con el pulsador                      */
/*                                                                                               */
/* ============================================================================================= */

// Definimos las entradas y salidas a emplear
#define PULSADOR ??   // Número de pin en que está conectado el pulsador
#define LEDB ?        // Número de pin en que está conectado el LED de color azul
#define LEDG ?        // Número de pin en que está conectado el LED de color verde
#define LEDR ?        // Número de pin en que está conectado el LED de color rojo

// Definimos las variables globales
int pulsado = 0;      // Para leer el estado del pulsador
int color = 0;        // Para establecer el color del LED
                      // 0 - Apagado
                      // 1 - Rojo
                      // 2 - Verde
                      // 3 - Azul

// Realizamos la configuración inicial
void setup() {
  Serial.begin(9600);              // Activamos el puerto serie
  Serial.println("Ejercicio 3: Cambio de color con pulsador");     // Mostramos mensaje inicial
  pinMode(????????, ?????);        // Configuramos el pin del pulsador como entrada
  pinMode(????, ??????);           // Configuramos el pin del LED rojo como salida
  pinMode(????, ??????);           // Configuramos el pin del LED verde como salida
  pinMode(????, ??????);           // Configuramos el pin del LED azul como salida
}

// Lanzamos el programa
void loop() {
  pulsado = digitalRead(????????);    // Lee estado del pulsador
  if (!pulsado)                       // Si está pulsado
  {
    do                                // Espera a que soltemos el pulsador
    {
      pulsado = digitalRead(????????);
      delay(??);                      // Retardo de 50 ms
    }
    while (!pulsado);                 // Mientras esté pulsado          
    
    color = color + 1;                // Incrementa color
    if (color == 4) color = 0;        // Para contar de 0 a 3

    switch(contador)                  // Dependiendo del valor del contador...
    {
      case 0: digitalWrite(????, ????);           // Apaga LED azul
              Serial.println("Apagado");          // Envía mensaje
              break;
      case 1: digitalWrite(????, ????);           // Enciende LED rojo
              Serial.println("Encendido ROJO");   // Envía mensaje
              break;
      case 2: digitalWrite(????, ????);           // Apaga LED rojo
              digitalWrite(????, ????);           // Enciende LED verde
              Serial.println("Encendido VERDE");  // Envía mensaje
              break;
      case 3: digitalWrite(????, ????);           // Apaga LED verde
              digitalWrite(????, ????);           // Enciende LED azul
              Serial.println("Encendido AZUL");   // Envía mensaje
              break;
    }
  }
  delay(100);                      // Inserta un retardo de 100 ms
}
