/* ============================================================================================= */
/*          UNIVERSITAT JAUME I - DEPARTAMENTO DE INGENIERÍA Y CIENCIA DE LOS COMPUTADORES       */
/*                            CURSO 'IoT CON ARDUINO Y ROBOT BUM'                                */
/*                   (c) 2017 Germán León, Raul Marín y José Vicente Martí                       */
/*                                                                                               */
/*                   Ejercicio 4: Cambio intensidad luminosa del LED con PWM                     */
/*                                                                                               */
/* ============================================================================================= */

// Definimos las entradas y salidas a emplear
#define PULSADOR ??   // Número de pin en que está conectado el pulsador
#define LEDR ?        // Número de pin en que está conectado el LED de color rojo

// Definimos las variables globales
int pulsado = 0;      // Para leer el estado del pulsador
int intensidad = 0;   // Nivel de intensidad luminosa

// Realizamos la configuración inicial
void setup() {
  Serial.begin(9600);              // Activamos el puerto serie
  Serial.println("Ejercicio 4: Cambio de intensidad con pulsador");     // Mostramos mensaje inicial
  Serial.println("Intensidad inicial ...... 0 ..... Maxima");
  pinMode(????????, ?????);        // Configuramos el pin del pulsador como entrada
  pinMode(????, ??????);           // Configuramos el pin del LED rojo como salida
}

// Lanzamos el programa
void loop() {
  pulsado = digitalRead(????????);    // Lee estado del pulsador
  if (!pulsado)                       // Si está pulsado
  {
    do                                // Espera a que soltemos el pulsador
    {
      ?????? = digitalRead(PULSADOR); // Lee el estado del pulsador
      delay (??);                     // Retardo de 50 ms
    }
    while (!pulsado);                 // Hasta que se suelte el pulsador                
    
    intensidad = intensidad + 50;             // Incrementa contador
    if (intensidad == 305) intensidad = 0;    // Para intensidad máxima tras apagado
    if (intensidad == 250) intensidad = 255;  // Apagado por completo

    Serial.print("Modificado intensidad ... ");
    Serial.print(??????????);                 // Envía nivel de intensidad
    if (intensidad == 255) Serial.print(" ... Apagado");
    if (intensidad == 0) Serial.print(" ..... Maxima");
    Serial.println();
    analogWrite(????, ?????????);              // Activa el LED con la intensidad correspondiente
  }
  delay(100);                      // Inserta un retardo de 100 ms
}
