/* ============================================================================================= */
/*          UNIVERSITAT JAUME I - DEPARTAMENTO DE INGENIERÍA Y CIENCIA DE LOS COMPUTADORES       */
/*                            CURSO 'IoT CON ARDUINO Y ROBOT BUM'                                */
/*                   (c) 2017 Germán León, Raul Marín y José Vicente Martí                       */
/*                                                                                               */
/*                      Ejercicio 6: Activación de los servos del robot BUM                      */
/*                                                                                               */
/* ============================================================================================= */

// Incluimos la librería de uso de los servos
#include <Servo.h>

// Declaramos un objeto "Servo" para cada uno de los que disponemos
Servo ServoD;     // Servo lado derecho
Servo ServoI;     // Servo lado izquierdo
Servo ServoP;     // Servo pinza
Servo MiniServo;  // MiniServo del medidor
int pos = 90;     // Para almacenar la posición de cada servo

// Inicializamos el sistema
void setup()
{
  // Asigna pines a los servos
  ServoD.attach(??);        // Pin en que se encuentra conectado el servo derecho
  ServoI.attach(??);       // Asigna el servo izquierdo al pin 10 (OUTPUT 1 de la TINKERKIT)
  ServoP.attach(??);        // Asigna el servo de la pinza al pin 5 (OUTPUT 4 de la TINKERKIT)
  MiniServo.attach(??);    // Asigna el miniservo al pin 11 (OUTPUT 0 de la TINKERKIT)

  // Inmoviliza servos  
  ServoD.write(90);  
  ServoI.write(97);  
  ServoP.write(90);    
  MiniServo.write(90);    
  
  Serial.begin(9600);                // Inicializamos la comunicación serie  
  Serial.println("Inicializado");    // Enviamos mensaje inicialización finalizada
}
 
void loop()
{
  
  Serial.println("==================================");
  Serial.println("=    MOVIMIENTO SERVO DERECHO    =");
  Serial.println("==================================");
  delay(1000);
  Serial.println("Acelerando servo derecho adelante");
  // Mueve servo derecho adelante
  for(pos = ??; pos <= ??; pos += 5)     
  {                                
    ServoD.write(pos);                 
    delay(100);                       
  }
  Serial.println("Servo derecho velocidad maxima adelante");
  delay(1000);
  
  Serial.println("Decelerando servo derecho");  
  for(pos = ??; pos>=??; pos -= 5)     
  {                                
    ServoD.write(pos);                           
    delay(100);                       
  }  
  Serial.println("Servo derecho detenido");
  delay(1000);
  
  Serial.println("Acelerando servo derecho atras");
  for(pos = ??; pos >= ??; pos -= 5)     
  {                                
    ServoD.write(pos); 
    delay(100);                       
  }
  Serial.println("Servo derecho velocidad maxima atras");
  delay(1000);
  
  Serial.println("Decelerando servo derecho"); 
  for(pos = ??; pos <= ??; pos += 5)     
  {                                
    ServoD.write(pos);              
    delay(100);                       
  }
  Serial.println("Servo derecho detenido");
  delay(2000); 

  Serial.println("==================================");
  Serial.println("=   MOVIMIENTO SERVO IZQUIERDO   =");
  Serial.println("==================================");
  delay(1000);
  Serial.println("Acelerando servo izquierdo adelante");
   for(pos = ??; pos >= ??; pos -= 5)     
  {                                
    ServoI.write(pos);              
    delay(100);                       
  }
  Serial.println("Servo izquierdo velocidad maxima adelante");
  delay(1000);
  
  Serial.println("Decelerando servo izquierdo");  
  for(pos = ??; pos <= ??; pos += 5)          
  {                                
    ServoI.write(pos);              
    delay(100);                       
  }
  Serial.println("Servo izquierdo detenido");
  delay(1000); 
  
  Serial.println("Acelerando servo izquierdo atras");
  for(pos = ??; pos <= ??; pos += 5)    
  {                                
    ServoI.write(pos);              
    delay(100);                       
  }
  Serial.println("Servo izquierdo velocidad maxima atras");
  delay(1000);
  
  Serial.println("Decelerando servo izquierdoo"); 
  for(pos = ??; pos >= ??; pos -= 5)
  {                                
    ServoI.write(pos);              
    delay(100);                       
  }
  Serial.println("Servo izquierdo detenido");
  delay(2000); 

  Serial.println("==================================");
  Serial.println("=      MOVIMIENTO MINISERVO      =");
  Serial.println("==================================");
  delay(1000);

  Serial.println("Girando medidor a la derecha");
  for(pos = ??; pos <= ??; pos += 2)     
  {                                
    MiniServo.write(pos);              
    delay(100);                       
  }
  Serial.println("Medidor girado a la derecha");
  delay(1000);  
  Serial.println("Devolviendo medidor al centro");
  for(pos = ??; pos >= ??; pos -= 2)     
  {                                
    MiniServo.write(pos);              
    delay(100);                       
  }
  Serial.println("Medidor centrado");
  delay(1000);  
  
  Serial.println("Girando medidor a la izquierda");
  for(pos = ??; pos >= ??; pos -= 2)     
  {                                
    MiniServo.write(pos);              
    delay(100);                       
  }
  Serial.println("Medidor girado a la izquierda");
  delay(1000);  
  Serial.println("Devolviendo medidor al centro");
  for(pos = ??; pos <= ??; pos += 2)     
  {                                
    MiniServo.write(pos);              
    delay(100);                       
  }
  Serial.println("Medidor centrado");
  delay(1000);  
  Serial.println("======== FIN DEL TEST ========");
  
  delay(5000);                   // Insertamos una espera
}

